    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ---------------------
    028 * ListWriteHandler.java
    029 * ---------------------
    030 * (C)opyright 2003-2005, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: ListWriteHandler.java,v 1.4 2005/10/18 13:35:21 mungady Exp $
    036 *
    037 * Changes
    038 * -------
    039 * 22-Nov-2003 : Initial version
    040 *
    041 */
    042
    043package org.jfree.xml.writer.coretypes;
    044
    045import java.io.IOException;
    046import java.util.Iterator;
    047import java.util.List;
    048
    049import org.jfree.xml.writer.AbstractXmlWriteHandler;
    050import org.jfree.xml.writer.XMLWriter;
    051import org.jfree.xml.writer.XMLWriterException;
    052import org.jfree.xml.writer.XMLWriterSupport;
    053
    054/**
    055 * A handler for writing a {@link List} object.
    056 */
    057public class ListWriteHandler extends AbstractXmlWriteHandler {
    058
    059    /**
    060     * Performs the writing of a {@link List} object.
    061     *
    062     * @param tagName  the tag name.
    063     * @param object  the {@link List} object.
    064     * @param writer  the writer.
    065     * @param mPlexAttribute  ??.
    066     * @param mPlexValue  ??.
    067     *
    068     * @throws IOException if there is an I/O error.
    069     * @throws XMLWriterException if there is a writer error.
    070     */
    071    public void write(final String tagName, final Object object, final XMLWriter writer,
    072                      final String mPlexAttribute, final String mPlexValue)
    073        throws IOException, XMLWriterException {
    074
    075        writer.writeTag(tagName, mPlexAttribute, mPlexValue, XMLWriterSupport.OPEN);
    076
    077        final List list = (List) object;
    078        final Iterator it = list.iterator();
    079        while (it.hasNext()) {
    080            final Object value = it.next();
    081            if (value == null) {
    082                writer.writeTag("null", XMLWriterSupport.CLOSE);
    083            }
    084            else {
    085                getRootHandler().write("object", value, Object.class, writer);
    086            }
    087        }
    088
    089        writer.writeCloseTag(tagName);
    090    }
    091
    092}